package org.dromara.work.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.RequiredArgsConstructor;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.work.domain.TpStaffPay;
import org.dromara.work.domain.bo.TpStaffPayBo;
import org.dromara.work.domain.vo.TpStaffPayVo;
import org.dromara.work.mapper.TpStaffPayMapper;
import org.dromara.work.service.ITpStaffPayService;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 客服支出记录Service业务层处理
 *
 * @author Maosw
 * @date 2024-08-12
 */
@RequiredArgsConstructor
@Service
public class TpStaffPayServiceImpl implements ITpStaffPayService {

    private final TpStaffPayMapper baseMapper;

    /**
     * 查询客服支出记录
     *
     * @param id 主键
     * @return 客服支出记录
     */
    @Override
    public TpStaffPayVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询客服支出记录列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 客服支出记录分页列表
     */
    @Override
    public TableDataInfo<TpStaffPayVo> queryPageList(TpStaffPayBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TpStaffPay> lqw = buildQueryWrapper(bo);
        Page<TpStaffPayVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的客服支出记录列表
     *
     * @param bo 查询条件
     * @return 客服支出记录列表
     */
    @Override
    public List<TpStaffPayVo> queryList(TpStaffPayBo bo) {
        LambdaQueryWrapper<TpStaffPay> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TpStaffPay> buildQueryWrapper(TpStaffPayBo bo) {
        LambdaQueryWrapper<TpStaffPay> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getOid() != null, TpStaffPay::getOid, bo.getOid());
        lqw.eq(bo.getPrice() != null, TpStaffPay::getPrice, bo.getPrice());
        lqw.eq(StringUtils.isNotBlank(bo.getContent()), TpStaffPay::getContent, bo.getContent());
        lqw.eq(bo.getAddUser() != null, TpStaffPay::getAddUser, bo.getAddUser());
        lqw.eq(bo.getAddTime() != null, TpStaffPay::getAddTime, bo.getAddTime());
        return lqw;
    }

    /**
     * 新增客服支出记录
     *
     * @param bo 客服支出记录
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TpStaffPayBo bo) {
        TpStaffPay add = MapstructUtils.convert(bo, TpStaffPay.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改客服支出记录
     *
     * @param bo 客服支出记录
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TpStaffPayBo bo) {
        TpStaffPay update = MapstructUtils.convert(bo, TpStaffPay.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TpStaffPay entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除客服支出记录信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
